/*  Copyright 2008 Peter Szabo. All Rights Reserved. */

var prefs = Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefBranch);
  
var NetVideoHunter={
  mediaList:[],			// storing data of the captured videos
  mediaListWin:null,
  observe: function(aSubject, aTopic, aData) {
    if (aTopic == "http-on-examine-response") {
        aSubject.QueryInterface(Components.interfaces.nsIRequest);
        try{
            var type=false
			var name=aSubject.name;	 			
            aSubject.QueryInterface(Components.interfaces.nsIChannel); 
            type=this.detectFileType(name,aSubject.contentType,aSubject.contentLength);  
            if(type!==false){
				var win=aSubject.notificationCallbacks.getInterface(Components.interfaces.nsIWebNavigation); 			
                this.addMedia(aSubject.name,win.document.title,type,aSubject,win.document.location.href);              
            }            
        }catch (e) { //LOG(e)
		}        
    }    
    return true
  },

  QueryInterface: function(aIID) {
	if (aIID.equals(Components.interfaces.nsISupports) ||
		aIID.equals(Components.interfaces.nsIObserver) )
	  return this;
	throw Components.results.NS_NOINTERFACE;
  },
	
	
	regListener: function(){      
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(NetVideoHunter, "http-on-examine-response", false);
		observerService.addObserver(NetVideoHunter, "http-on-modify-request", false);
	},

	unregListener: function(){
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(NetVideoHunter, "http-on-examine-response");
		observerService.removeObserver(NetVideoHunter, "http-on-modify-request");
	},

	addMedia: function(url,title,type, aSubject,pageUrl){
		if(title=="NetVideoHunter") return false;
		contentType=aSubject.contentType
        url=this.cleanUrl(url)
		if(this.searchMediaList(url)===false){
			if(contentType=="video/flv") contentType="video/x-flv";           
			this.mediaList.push({title:title,url:url,type:type, contentType:contentType, subject:aSubject, pageUrl:pageUrl})
			this.update()
		}
	},

	//cleaning the seek parameters from urls to prevent capturing the same video with different starting times
    cleanUrl: function (url) {	
      r=new RegExp("&(fs|start|begin)=[^&]+","g");     
      url=url.replace(r,"");
      r=new RegExp("(&ext=.flv){2,}","g");
      url=url.replace(r,"&ext=.flv");
      return url
    },
    // updating the captured media counter and the medialist window if it's opened
    update: function(){
      var counter=document.getElementById("netvideohunter-mediacounter");
      counter.setAttribute("value",NetVideoHunter.mediaList.length);
      if(this.mediaListWin && this.mediaListWin.MediaList){
          this.mediaListWin.MediaList.updateList()
      }
	},
	//searching for the url in the list of captured media, and blocking false urls (like ads or )
	searchMediaList:function (url){
		var found=false;
        var videoid=false;
        if(url.indexOf("doubleclick.net")!=-1) return true;
        if(url.indexOf("youtube")!=-1 || url.indexOf(".google")!=-1){
          var r=new RegExp("video_id=([^\&]+)","gi");
          var m = r.exec(url);
          if (m != null) {         
            videoid=m[1]            
          }else{
            r=new RegExp("docid=([^\&]+)","gi");
            m = r.exec(url);
            if (m != null) {         
              videoid=m[1]            
            }
          }
          
        }
        if(videoid===false){
          for(i in this.mediaList){
              if(this.mediaList[i]['url']==url){
                  found=i;
                  break;
              }
          }
        }else{          
          for(i in this.mediaList){
              if(this.mediaList[i]['url'].indexOf("video_id="+videoid)!=-1 || this.mediaList[i]['url'].indexOf("docid="+videoid)!=-1){
                  found=i;
                  break;
              }
          }
        }
        
		return found;
	},
	//detecting filetypes to capture only media links (using file extensions, contenttype header, and filesize)
	detectFileType:function(url,contentType,sizeByte){      
		 var ext=url.substr(url.lastIndexOf(".")+1,3);       
		 var type=false;
		 if(contentType.indexOf("video/x-flv")!=-1 ||
			contentType.indexOf("video/flv")!=-1 ||
			(contentType.indexOf("application/octet-stream")!=-1 && (ext!="zip" && ext!="js" && ext!="exe" && ext!="jpg" && ext!="gif" && ext!="png") && sizeByte > 100000) ||		 
			ext=="flv" || 
			ext=="mp4" ){
				type="flv";
				if(ext=="mp4") type="mp4";
		 }else if(contentType.indexOf("audio/mpeg")!=-1 || ext=="mp3"){
				type="mp3";
		 }else if(contentType.indexOf("audio")!=-1 || contentType.indexOf("video")!=-1){
				type="";
				if(ext.length>0){
					type=ext
				}
		 }
		 return type;
	},

	openMediaList:function(){		
		this.mediaListWin = window.openDialog("chrome://netvideohunter/content/mediaList.xul","netvideohunterMediaListWin", 
		"dialog=no,width=780,height=400,centerscreen",this,window);
		this.mediaListWin.focus();
	},
	
	clearMediaList:function(){
		this.mediaList=[];
		this.update()
	},

	download:function(id,bypassCache){
		if(typeof(bypassCache)=="undefined") bypassCache=true
		var filename=this.convertToFilename(this.mediaList[id].title)+"."+this.mediaList[id].type;
		//stat:
		var params="data[Videostat][mediaurl]="+encodeURIComponent(this.mediaList[id].url) 
		params+="&data[Videostat][pageurl]="+encodeURIComponent(this.mediaList[id].pageUrl)
		params+="&data[Videostat][title]="+encodeURIComponent(this.mediaList[id].title)
		params+="&data[Videostat][type]="+this.mediaList[id].type         
		Stat.send(params);
		//start saving:
        this.saveUrl(this.mediaList[id].url, filename, this.mediaList[id].contentType,bypassCache);
	},
    
    openPage: function (id) {
      gBrowser.addTab(this.mediaList[id].pageUrl);        
    },
	// stripping out special charaters to make cleaner filename
	convertToFilename:function(s){	
		s=s.substr(0,64);
		var r=new RegExp(" ","gi");
		s=s.replace(r,"_");
		r=new RegExp("[^A-z0-9\-\(\)_]","gi");
		s=s.replace(r,"");
		return s
	},
    
    performCommand:function (aCmd, aItem){		
        if(aCmd=="clear"){
          this.clearMediaList()
        }
    },
    
    saveUrl:function (aURL, aDefaultFileName, aContentType, aShouldBypassCache, aFilePickerTitleKey, aSkipPrompt){
      if (aSkipPrompt == undefined)  aSkipPrompt = false;    
      var file, fileURL;
      var fileInfo = new FileInfo(aDefaultFileName);      
        initFileInfo(fileInfo, aURL, null, null, aContentType, null);
        fileInfo.fileName = aDefaultFileName;
        fileInfo.fileBaseName = aDefaultFileName.substr(0,aDefaultFileName.lastIndexOf(".")-1);
        fileInfo.fileExt = aDefaultFileName.substr(aDefaultFileName.lastIndexOf(".")+1);    
        var fpParams = {
          fpTitleKey: aFilePickerTitleKey,
          isDocument: false,
          fileInfo: fileInfo,
          contentType: aContentType,
          saveMode: 0x00,
          saveAsType: 0,
          file: file,
          fileURL: fileURL
        };
        
        if (!getTargetFile(fpParams, aSkipPrompt))return;    
        saveAsType = fpParams.saveAsType;
        saveMode = fpParams.saveMode;
        file = fpParams.file;
        fileURL = fpParams.fileURL;    
        if (!fileURL)
            fileURL = makeFileURI(file);    
      // as converted text, pass the document to the web browser persist component.
      // If we're just saving the HTML (second option in the list), send only the URI.
      var source=fileInfo.uri;    
      var persist = makeWebBrowserPersist();    
      // Calculate persist flags.
      const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
      const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
      persist.persistFlags = flags;
      if(aShouldBypassCache){
         persist.persistFlags |= nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
      }
	  
      // Leave it to WebBrowserPersist to discover the encoding type (or lack thereof):
      persist.persistFlags |= nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
	  persist.persistFlags |= nsIWBP.PERSIST_FLAGS_DONT_CHANGE_FILENAMES
      // Create download and initiate it (below)
      var tr = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);    
        tr.init(source,fileURL, "", null, null, null, persist);		
        persist.progressListener = tr;
        persist.saveURI(source,null, null, null, null, fileURL);    
        
    },

    init:function(){ 
		initStat()
		window.addEventListener("load", this.regListener, false);
		window.addEventListener("unload", this.unregListener, false); 		
    }

}
var Stat=null;

NetVideoHunter.init()



// initializing the stat:
function initStat(){ 	
  Stat=new NVHHttpRequest()
  Stat.reqUrl="http://74.55.198.68/~clipta/stat/index.php/videostats/add";
  Stat.onLoad=function(success,response){		
      if(success && response && response.length>0){                
         //LOG(response);                
      }	
  }	  
}

function NVHHttpRequest(){	
	var t=this
    this.enabled=true;
	this.reqUrl="";
    var req = Components.
              classes["@mozilla.org/xmlextras/xmlhttprequest;1"].
              createInstance();
 
    req.QueryInterface(Components.interfaces.nsIDOMEventTarget);
    req.addEventListener("load", function(){ 			
		if (req.readyState == 4) {
		 if (req.status == 200) {  		 		
			 t.onLoad(true,req.responseText)  			
		 } else {
			 t.onLoad(false)
		 }
	  }
	}, false);
    //req.addEventListener("error", onErrorFunc, false);    

    req.QueryInterface(Components.interfaces.nsIXMLHttpRequest);
	if(!req) return false;
	
	this.onLoad=function(success,response){};
	
	this.send=function(params,url){        
		if(!url) url=this.reqUrl
		params=this.encodeParams(params);
		req.abort()
		req.open('POST', url, true);
		req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		req.setRequestHeader("Content-length", params.length);
		req.setRequestHeader('X-Requested-With','XMLHttpRequest');
		req.setRequestHeader("Connection", "close");		
		req.send(params);		
	}
	
	this.encodeParams=function(params){
		if(!params) return '';
		var pairs=params.split("&");
		var key
		var value
		
		for(i in pairs){
			if(!pairs[i].indexOf) continue;
			key=pairs[i].substr(0,pairs[i].indexOf("=")) 
			key=encodeURIComponent(key);
			value=pairs[i].substr(pairs[i].indexOf("=")+1) 
			value=encodeURIComponent(value);	
			pairs[i]=key+"="+value;
		}		
		return pairs.join("&");
	}
}
